{-# OPTIONS_GHC -Wall -fno-warn-orphans #-}
{-# LANGUAGE ScopedTypeVariables #-}

module HarmTrace.Models.Pop.Main ( 
    pPop
  , module HarmTrace.Models.Pop.Model
  ) where

-- Parser stuff
import Text.ParserCombinators.UU

-- Music stuff
import HarmTrace.Base.MusicRep
import HarmTrace.Models.Parser
import HarmTrace.Models.Pop.Model hiding (PD,PT)

import HarmTrace.Models.Pop.Instances ()


--------------------------------------------------------------------------------
-- From tokens to structured music pieces
--------------------------------------------------------------------------------

pPieceMaj, pPieceMin :: forall key. PMusic [Piece key]
pPieceMaj = map Piece <$> amb (parseG :: PMusic [Phrase key MajMode])
pPieceMin = map Piece <$> amb (parseG :: PMusic [Phrase key MinMode])

pPop :: forall key. Key -> PMusic [Piece key]
pPop (Key _ MajMode) = pPieceMaj
pPop (Key _ MinMode) = pPieceMin

